;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Serial Control				|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
ifndef	hyoka
;===============================================================|
;			I/O Address				|
;===============================================================|
COMM_DATA		equ	0b1h	;Send / Receive data
COMM_STATUS		equ	0b3h	;Serial Status
;===============================================================|
;			INT Status bit flag			|
;===============================================================|
INT_CommSendSet		equ	001h	;CommSendlZbg@(or)
INT_CommSendReset	equ	0feh	;CommSendlZbg(and)
;===============================================================|
;			COMM Status bit flag			|
;===============================================================|
COMM_Receive		equ	001h	;Mf[^LiMj
COMM_OverRun		equ	002h	;I[o[EG[
COMM_SendEmpty		equ	004h	;Mobt@iMj
COMM_OrReset		equ	020h	;I[o[EG[̃Zbg
COMM_Baudrate9K		equ	000h	;{[[gi 9600 [bps])(+)
COMM_Baudrate38k	equ	040h	;{[[gi38400 [bps])(+)
COMM_Enable		equ	080h	;ʐMCl[u(or)
COMM_Disable		equ	07fh	;ʐMfBZ[u(and)
;===============================================================|
;			萔					|
;===============================================================|
COMM_TimeOut		equ	0ffffh	;^CAEg̎
;===============================================================|
;			ʐMJ				|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;		38400bpsɐݒAʐMJB		|
;===============================================================|
	even				;AhXzu
C_Open	proc near			;
	push	ax			;
	push	bx			;
	
	mov	al,COMM_OrReset + COMM_Baudrate38k + COMM_Enable
	out	COMM_Status,al		;

	pop	bx			;
	pop	ax			;
	ret				;
C_Open	endp				;
;===============================================================|
;			ʐM			|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;		ʐMB				|
;===============================================================|
	even				;AhXzu
C_Close	proc near			;
	push	ax			;

C_Close_2:				;
	in	al,COMM_Status		;Xe[^Xǂݍ
	test	al,COMM_Enable		;ʐM@\̓Cl[uH
	jz	C_Close_1		;
	test	al,COMM_SendEmpty	;Mf[^H
	jz	C_Close_2		;łȂ΁AɂȂ܂ő҂B
C_Close_1:				;
	and	al,COMM_Disable		;ʐMfBZ[uݒB
	out	COMM_Status,al		;o

	in	al,Int_Enable		;
	and	al,INT_CommSendReset	;VAMGveB[
	out	Int_Enable,al		;荞݋֎~

	pop	ax			;
	ret				;
C_Close	endp				;
;===============================================================|
;			1 byteM				|
;===============================================================|
;								|
;		al	send data				|
;	Ԃl							|
;								|
;								|
;		Ƀf[^o͂B			|
;===============================================================|
	even				;AhXzu
C_Send	proc near			;
	pushf				;
	push	es			;
	push	di			;
	push	bx			;
	push	ax			;WX^ۑ
	cli

	in	al,Int_Enable		;
	and	al,INT_CommSendReset	;VAMGveB[
	out	Int_Enable,al		;荞݋֎~

	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	cmp	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	jnz	C_Send_0		;FIFOobt@H

	in	al,COMM_Status		;Xe[^Xǂݍ
	test	al,COMM_SendEmpty	;Mobt@H
	jz	C_send_0		;

	pop	ax			;
	out	COMM_DATA,al		;M
	pop	bx			;
	pop	di			;
	pop	es			;
	popf				;
	ret				;
;----------------------------------------------------------------
C_Send_0:
	mov	ax,ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	mov	di,ax			;axFIFO|C^Cnt

	mov	bx,ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt

	inc	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	cmp	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Size
	jnz	C_Send_1		;
	mov	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt,0
C_Send_1:				;
	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	cmp	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	jnz	C_Send_3		;FIFOobt@͂ςH
	mov	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt,bx
	call	IC_Send			;FIFȎM݂āA
	jmp	C_Send_1		;蒼B

C_Send_3:				;
	mov	bx,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Offset
	mov	es,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Segment
	pop	ax			;FIFOobt@ɏ
	push	ax			;
	mov	byte ptr es:[di+bx],al	;

C_Send_e:
	in	al,Int_Enable		;obt@Ƀf[^̂ŁA
	or	al,INT_CommSendSet	;VAMGveB[
	out	Int_Enable,al		;荞݋

	pop	ax			;
	pop	bx			;
	pop	di			;WX^A
	pop	es			;
	popf				;
	ret				;
C_Send	endp				;
;===============================================================|
;	even				;AhXzu
;C_Send	proc near			;
;	push	cx			;
;	push	ax			;WX^ۑ
;
;	mov	cx,COMM_TimeOut		;count
;	xchg	al,ah			;
;C_send_1:				
;	dec	cx			;time count
;	jz	C_send_e		;[v΍
;	in	al,COMM_Status		;Xe[^Xǂݍ
;	test	al,COMM_SendEmpty	;Mobt@H
;	jz	C_send_1		;
;	xchg	al,ah			;
;	out	COMM_DATA,al		;M
;	or	ax,ax			;Cy flag reset
;
;C_Send_e:
;	pop	ax			;WX^A
;	pop	cx			;
;	ret				;
;C_Send	endp				;
;===============================================================|
;			2 byteM				|
;===============================================================|
;								|
;		ax	send data(al:LSB,ah:MSB)		|
;	Ԃl							|
;								|
;								|
;		Ƀf[^o͂B			|
;===============================================================|
	even				;AhXzu
C_Send_Word	proc near		;
	call	C_Send			;
	xchg	al,ah			;
	call	C_Send			;
	xchg	al,ah			;
	ret				;
C_Send_Word	endp			;
;===============================================================|
;			ubNM				|
;===============================================================|
;								|
;		CX	Size					|
;		DS:SI	Data Address				|
;	Ԃl							|
;								|
;								|
;		Ƀf[^o͂B			|
;===============================================================|
	even				;AhXzu
C_Send_Block	proc near		;
	push	si			;
	push	cx			;
	push	ax			;WX^ۑ

C_Send_Block_1:
	lods	byte ptr es:[si]	;
	call	C_Send			;M
	loop	C_Send_Block_1		;
	
	pop	ax			;WX^A
	pop	cx			;
	pop	si			;
	ret				;
C_Send_Block	endp			;
;===============================================================|
;			1 byteM				|
;===============================================================|
;								|
;		FIFO	send data				|
;	Ԃl							|
;								|
;								|
;		Ƀf[^o͂B			|
;===============================================================|
	even				;AhXzu
IC_Send:
	push	es			;
	push	di			;
	push	bx			;
	push	ax			;
	pushf				;
	cli				;

;---------------------------------------------------------------
	in	al,Int_Enable		;
	and	al,INT_CommSendReset	;VAMGveB[
	out	Int_Enable,al		;荞݋֎~

	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	cmp	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	jz	IC_Send_e		;FIFOobt@H

	in	al,COMM_Status		;Xe[^Xǂݍ
	test	al,COMM_SendEmpty	;Mobt@H
	jz	IC_send_e0		;Ze'H'

	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	mov	di,ax			;FIFO|C^̎擾

	inc	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	cmp	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Size
	jnz	IC_Send_1		;
	mov	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr,0
IC_Send_1:				;
	mov	bx,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Offset
	mov	es,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Segment
	mov	al,byte ptr es:[di+bx]	;
	out	COMM_DATA,al		;M

IC_Send_e0:
	in	al,Int_Enable		;
	or	al,INT_CommSendSet	;VAMGveB[
	out	Int_Enable,al		;荞݋

IC_Send_e:
	popf				;
	pop	ax			;
	pop	bx			;
	pop	di			;
	pop	es			;
	ret				;
;===============================================================|
endif
