;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Interrupt main program			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
;****************************************************************
;*								*
;*			萔					*
;*								*
;****************************************************************
;
;	͖
;
;****************************************************************
;*								*
;*			f[^e[u				*
;*								*
;****************************************************************
;===============================================================|
;			Volume					|
;===============================================================|
;								|
;	Table = 256 * log(volume +1) / log(257)			|
;								|
;===============================================================|
	even
I_Volume_Table:
;		00h,01h,02h,03h,04h,05h,06h,07h,08h,09h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
	db	  0, 31, 50, 63, 74, 82, 89, 95,101,106,110,114,118,121,124,127
	db	130,133,135,138,140,142,144,146,148,150,152,153,155,156,158,159
	db	161,162,164,165,166,167,169,170,171,172,173,174,175,176,177,178
	db	179,180,181,182,183,184,184,185,186,187,188,188,189,190,191,191
	db	192,193,193,194,195,195,196,197,197,198,199,199,200,200,201,202
	db	202,203,203,204,204,205,206,206,207,207,208,208,209,209,210,210
	db	211,211,211,212,212,213,213,214,214,215,215,216,216,216,217,217
	db	218,218,218,219,219,220,220,220,221,221,222,222,222,223,223,223
	db	224,224,224,225,225,225,226,226,226,227,227,227,228,228,228,229
	db	229,229,230,230,230,231,231,231,232,232,232,232,233,233,233,234
	db	234,234,234,235,235,235,236,236,236,236,237,237,237,238,238,238
	db	238,239,239,239,239,240,240,240,240,241,241,241,241,242,242,242
	db	242,243,243,243,243,243,244,244,244,244,245,245,245,245,246,246
	db	246,246,246,247,247,247,247,247,248,248,248,248,249,249,249,249
	db	249,250,250,250,250,250,251,251,251,251,251,252,252,252,252,252
	db	253,253,253,253,253,253,254,254,254,254,254,255,255,255,255,255
;===============================================================|
;			Frection(Key)				|
;===============================================================|
;								|
;	Table = (3.072[MHz] / (32 * frection)) * 2^7		|
;								|
;		Frection : a = 440[Hz]				|
;								|
;								|
;	DeviceOut = 2048 - (Table / 2^(3 + Octave))		|
;								|
;===============================================================|
	even				;AhXzu
I_Frection_Table:
	dw	46978			;c	Bend Range  4
	dw	44332			;c#		( 3` 6)
	dw	41843			;d	
	dw	39495			;d#	
	dw	37278			;e	
	dw	35186			;f	
	dw	33211			;f#	
	dw	31347			;g	
	dw	29687			;g#	
	dw	27922			;a	
	dw	26360			;a#	
	dw	24880			;b	
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉEobl	*
;*								*
;****************************************************************
;*								*
;*	@t						*
;*								*
;*	EԒli̒l͕ۂKvBj		*
;*		ds:bx	L\̃AhX			*
;*		ds:bp	[Nx[XAhX			*
;*								*
;*	WX^U					*
;*		ax	ėp(ɌvZ)				*
;*		ds:bx	L\̃AhX			*
;*		cx	ėp(ɃJE^)			*
;*		dx	ėp(ɌvZ)				*
;*		ds:di	ʍ\				*
;*		es:si	tAhX				*
;*		ds:bp	[Nx[XAhX			*
;*								*
;****************************************************************
;===============================================================|
;		Interrupt Main					|
;===============================================================|
;								|
;								|
;		@t[`̌ĂяoA			|
;		^C}[̐s[`B			|
;								|
;	gpWX^						|
;		ds:bp	[N̈擪AhX			|
;		ds:bx	p[gʍ\			|
;								|
;===============================================================|
	Public	I_Start
	even					;AhXzu
I_Start:
	push	ax				;
	push	bx				;
	push	cx				;
	push	dx				;
	push	si				;
	push	di				;
	push	bp				;
	push	ds				;WX^ۑ

;---------------------------------------------------------------
;EOI̔s

	cli					;荞ݕs

;End Of Interrupt
	mov	al,Int_HblankSet		;
	out	Int_Eoi,al			;o

;	in	al,Int_Enable			;
;	and	al,INT_HblankReset		;VAMGveB[
;	out	Int_Enable,al			;荞݋֎~
;---------------------------------------------------------------
;oN̐ݒ
ifndef	IRAM		;DGROUP=IRAM̏ꍇAsv
	in	al,BankSram			;݂SRAM Bank𓾂
	cmp	al,BANK_USERDS0			;[ÜĂA
	jz	I_Start_Step1			;͍̏sȂB
	cmp	al,BANK_USERDS1			;
	jz	I_Start_Step1			;'/ram0'ANZX́A
	jmp	I_Start_End			;ȂB
endif

I_Start_Step1:

;---------------------------------------------------------------
;[NGAAhX̎擾

;	push	SRAM_Segment			;
;	pop	ds				;dsSRAMZOg
;	mov	bp,ds:[ProcContext_heap]	;ds:bx[NGAAhX
	WTD_WorkGet	ds,bp			;[NGAAhX̎擾
	mov	bx,bp				;
	add	bx,WTD_WorkAdd_System		;ds;bxʍ\

;---------------------------------------------------------------
;tEʉEPcmVoice[`̌Ăяo

	;^C}[G~[g邩H
	test	ds:[bx].WTD_Sys_Flag,WTD_Sys_TimerEmulate
	jz	I_Start_Step2				;

	;------------------------------------------------
	;^C}[G~[g鎞ɒǉ鏈B	;
	;CALL߂ƁAret߂6clockܑ̂Ȃ		;
	;------------------------------------------------
	;PCM Voice					;
	test	ds:[bx].WTD_Sys_Flag,WTD_Sys_Pcm	;PCM Voice炷H
	jz	I_PcmStep				;

	;WX^ݒ
	mov	di,bp					;
	add	di,WTD_WorkAdd_PCM			;dip[gʍ\
	push	es					;WX^ۑ

	;AhX擾
	les	si,dword ptr ds:[di].WTD_PcmAddress	;es:siPlay Address
	mov	dx,es					;dx:siPlay Address
	;f[^擾
	mov	al,es:[si]				;(ӁFPipeLine)
	inc	si					;
	;f[^o
	out	PCM_Com_VolumeCh2,al			;o

	;|C^`FbNiZOgEHj
	jnz	I_PcmVoice_Step1			;
	add	dx,1000h				;ZOg₷
I_PcmVoice_Step1:					;
	;AhXۑ
	mov	word ptr ds:[di].WTD_PcmAddress+0,si	;AhXۑ
	mov	word ptr ds:[di].WTD_PcmAddress+2,dx	;(ӁFPipeLine)

	;IH
	sub	word ptr ds:[di].WTD_PcmSize+0,1	;PcmSize fBNg
	sbb	word ptr ds:[di].WTD_PcmSize+2,0	;
	mov	ax,word ptr ds:[di].WTD_PcmSize+0	;
	or	ax,word ptr ds:[di].WTD_PcmSize+2	;
	jnz	I_PcmVoice_End				;

	;I
	and	ds:[bx].WTD_Sys_Flag,WTD_Sys_PcmR	;I

I_PcmVoice_End:						;
	pop	es					;WX^A
I_PcmStep:						;
	;PCM VoiceI				;
	;---------------				;
	;e|pJE^[@fBNg		;
	dec	ds:[bx].WTD_Sys_TempoCounter		;
	jnz	I_MusicEffectStep			;t΂B
	;------------------------------------------------
	;^C}[G~[g̏܂ŁB		;
	;------------------------------------------------

I_Start_Step2:						;Music & Effect	
	call	I_MusicEffect				;
I_MusicEffectStep:					;

;	in	ax,TIMER_CounterH		;
;	test	ax,ax				;܁[JE^[O
;	jz	I_Start_Step1			;AB
;
;---------------------------------------------------------------
;oN̕A
ifndef	IRAM		;DGROUP=IRAM̏ꍇAsv
;
;	pop	ax				;A
;	out	BankSram,al			;ݒ肷B
;
endif
;---------------------------------------------------------------
;荞݂̏I
;
I_Start_End:
;	cli				;荞݋֎~
;
;	in	al,Int_Enable		;
;	or	al,INT_HblankSet	;^C}[
;	out	Int_Enable,al		;荞݋

	pop	ds				;WX^A
	pop	bp				;
	pop	di				;
	pop	si				;
	pop	dx				;
	pop	cx				;
	pop	bx				;
	pop	ax				;
	iret					;
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*								*
;****************************************************************
;===============================================================|
;		Music Main					|
;===============================================================|
;	WX^gp						|
;		ax	ėp(ɌvZ)				|
;		ds:bx	L\̃AhX			|
;		cx	ėp(ɃJE^)			|
;		dx	ėp(ɌvZ)				|
;		ds:di	ʍ\				|
;		ds:bp	[Nx[XAhX			|
;		es:si	tAhX				|
;===============================================================|
	even					;AhXzu
I_MusicEffect:					;
	push	es				;WX^ۑ
;---------------------------------------------------------------
;t[`

;t邩H
	test	ds:[bx].WTD_Sys_Flag,WTD_Sys_Music	;
	jz	I_MusicEffect_MusicStep			;

;WX^ݒ
	mov	di,bp				;
	add	di,WTD_WorkAdd_Ch0		;dip[gʍ\
	mov	ax,ds:[bx].WTD_Sys_MusicSegment	;
	mov	es,ax				;estf[^ZOg


;t[`̌Ăяo
	xor	cx,cx				;ił͍ő'20'B
	mov	cl,ds:[bx].WTD_Sys_MusicPart	;ł͍ő' 4'B
	or	cx,cx				;
	jz	I_MusicEffect_MusicStep		;
	even					;AhXzu
I_MusicEffect_MusicLoop:			;
	call	I_Play				;
	add	di,WTD_WorkChSize		;\̂̃TCY80h(0x80)
	sub	cx,1				;
	jnz	I_MusicEffect_MusicLoop		;

I_MusicEffect_MusicStep:

;---------------------------------------------------------------
;ʉ[`

;ʉ邩H
	test	ds:[bx].WTD_Sys_Flag,WTD_Sys_Effect	;
	jz	I_MusicEffect_EffectStep		;

;WX^ݒ
	mov	di,bp				;
	add	di,WTD_WorkAdd_Ech0		;dip[gʍ\
	mov	ax,ds:[bx].WTD_Sys_EffectSegment
	mov	es,ax				;esʉf[^ZOg

;t[`̌Ăяo
	xor	cx,cx				;
	mov	cl,ds:[bx].WTD_Sys_EffectPart	;ő'3'B
	or	cx,cx				;
	jz	I_MusicEffect_EffectStep	;
	even					;AhXzu
I_MusicEffect_EffectLoop:			;
	call	I_Play				;
	add	di,WTD_WorkChSize		;\̂̃TCY80h(0x80)
	sub	cx,1				;
	jnz	I_MusicEffect_EffectLoop	;

I_MusicEffect_EffectStep:			;

;---------------------------------------------------------------
;PCM VioceʉĂAIłȂ΁A
;^C}[߂B

;^C}[G~[gł邩H
	test	ds:[bx].WTD_Sys_Flag,WTD_Sys_TimerEmulate
	jz	I_MusicEffect_PcmCheck_End		;

;PcmVioceIH
	test	ds:[bx].WTD_Sys_Flag,WTD_Sys_Pcm	;
	jnz	I_MusicEffect_PcmCheck_Step1		;

;PcmVioceȈꍇB
;tO
	mov	ax,ds:[bx].WTD_Sys_Flag		;
;	and	ax,WTD_Sys_PcmR			;PCMʉfBZ[u
;	and	ax,WTD_Sys_PcmEndR		;̃tO͔p~
	and	ax,WTD_Sys_EffectMask2R		;ch2 ʉ}XNRes
	and	ax,WTD_Sys_TimerEmulateR	;^C}[G~[gRes
	mov	ds:[bx].WTD_Sys_Flag,ax		;
;^C}[ݒ
	mov	ax,ds:[bx].WTD_Sys_Tempo	;^C}[̐ݒ
	call	T_Set_Frection			;
;^C}[JE^ݒ
	xor	ax,ax				;ax0
	mov	ds:[bx].WTD_Sys_TempoCounter,ax	;TempoCounter = 0
;channel 2  ݒ蕜A
	mov	ch,81h				;ݒ蕜Ach2
	call	I_Effect_Return			;
;I
	jmp	I_MusicEffect_PcmCheck_End	;

;PcmViocep̏ꍇ
I_MusicEffect_PcmCheck_Step1:			;
;^C}[ݒ
	mov	ax,1				;荞ݎ͍ő
	call	T_Set_Frection			;(12KHz)
;^C}[JE^ݒ
	mov	ax,ds:[bx].WTD_Sys_Tempo	;
	mov	ds:[bx].WTD_Sys_TempoCounter,ax	;TempoCounter
;I
;	jmp	I_MusicEffect_PcmCheck_End	;

;I
I_MusicEffect_PcmCheck_End:			;

;---------------------------------------------------------------
;I
	pop	es				;WX^A
	ret					;
;===============================================================|
;		Music Control Main				|
;===============================================================|
;	WX^gp						|
;		ax	ėp(ɌvZ)				|
;		ds:bx	L\̃AhX			|
;		cx	ėp(ɃJE^)			|
;		dx	ėp(ɌvZ)				|
;		ds:di	ʍ\				|
;		ds:bp	[Nx[XAhX			|
;		es:si	tAhX				|
;===============================================================|
	even				;AhXzu
I_Play:					;
	pusha				;
;---------------------------------------------------------------

;t`FbN
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PlayEnd
	jz	I_Play_Step1			;
	jmp	I_Play_StepE			;
I_Play_Step1:					;

;JE^[EfBNg
	dec	ds:[di].WTD_LengCounter		;

;ɂAL[IfBC
	mov	ax,ds:[di].WTD_Leng		;'k'R}h̔
	sub	ax,ds:[di].WTD_LengCounter	;
	cmp	ax,ds:[di].WTD_KeyOnDelay	;
	jnz	I_Play_Step2			;
	call	I_Play_KeyOn			;
I_Play_Step2:					;

;ɂAF
	test	ds:[di].WTD_Program2nd,80h	;Kv̊mF
	jnz	I_Play_Step8			;
	cmp	ds:[di].WTD_Key,0ffh		;xH
	jz	I_Play_Step8			;
	mov	ax,ds:[di].WTD_Leng		;'@'R}h
	sub	ax,ds:[di].WTD_LengCounter	;
	cmp	ax,ds:[di].WTD_ProgramRate	;
	jnz	I_Play_Step8			;
	push	ax				;
	mov	al,ds:[di].WTD_Program2nd	;
	and	al,07fh				;bit̃}XN
	mov	dx,offset CGROUP:I_Table_Voice	;
	call	I_Table_Jump			;
	pop	ax				;
I_Play_Step8:					;

;ɂAQ[g^C
	cmp	ax,ds:[di].WTD_GateTimeStepFirst
	jz	I_Play_Step3			;'u'R}h̔
	mov	ax,ds:[di].WTD_Leng		;'Q','U','q'R}h̔
	mov	ch,ds:[di].WTD_GateTime8	;chGateTime8
	rol	ch,1				;
	shr	ch,1				;Bit 7 Reset & Bit 7 -> Cy Flag
	jc	I_Play_Step5			;

	mov	dx,8				;'Q'R}h
	sub	dl,ch				;dx = 8 | ch
	mul	dx				;dx:ax = ax ~ dx
	shr	dx,1				;
	shr	ax,1				;
	shr	dx,1				;
	shr	ax,1				;
	shr	dx,1				;
	shr	ax,1				;ax = dx:ax  cl
	jmp	short I_Play_Step6		;

	even					;AhXzu
I_Play_Step5:					;'U'R}h
	mov	cl,100				;cl = 100
	mov	dx,100				;dx = 100
	sub	dl,ch				;dx = dx | ch
	mul	dx				;dx:ax = ax ~ dx
	xor	ch,ch				;
	div	cx				;ax = dx:ax  cl
I_Play_Step6:					;
	add	ax,ds:[di].WTD_GateTimeStepLast	;ax = ax + WTD_GateTimeStepLast
	jnc	I_Play_Step7			;I[o[t[A
	mov	ax,0ffffh			;őlɏCB
I_Play_Step7:					;
	cmp	ax,ds:[di].WTD_LengCounter	;
	jnz	I_Play_Step4			;
I_Play_Step3:					;
	call	I_Play_KeyOff			;
I_Play_Step4:					;

;JE^OȂ΁AR}h
	cmp	ds:[di].WTD_LengCounter,0		;JE^OH
	jnz	I_Play_StepE				;
	mov	si,ds:[di].WTD_Address			;es:siPlay Address
	call	I_Play_Loop				;䃋[`ցB
	mov	ds:[di].WTD_Address,si			;
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PlayEnd
	jnz	I_Play_StepE				;tIH
	cmp	ds:[di].WTD_KeyOnDelay,0		;KeyOnDelay͂OH
	jnz	I_Play_StepE				;
	call	I_Play_KeyOn				;ł΁AKeyOn

;䃋[`
I_Play_StepE:					;
	call	I_Play_Pan			;p
	call	I_Play_Volume			;ʐ
	cmp	ds:[di].WTD_ExprSet,0		;@ʂOA
	jz	I_Play_StepEnd			;@ȉ͖̏B
	call	I_Play_Frection			;

;---------------------------------------------------------------
I_Play_StepEnd:				;
	popa				;
	ret				;
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				[v				*
;*								*
;****************************************************************
	even				;AhXzu
I_Play_Loop:				;
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PlayEnd
	jnz	I_Loop_StepE		;t`FbN
	cmp	ds:[di].WTD_LengCounter,0
	jnz	I_Loop_StepE		;`FbN
	jmp	I_Loop_Step1		;
I_Loop_StepE:				;
	ret				;
	even				;AhXzu
I_Loop_Step1:				;

;tf[^ǂݍ
	mov	al,es:[si]		;
	inc	si			;

;R}h^Cv`FbN
	rol	al,1			;
	shr	al,1			;cyCommand Type

;ꂼ֏R[ĚA[vB
	jc	I_Loop_Step2		;
	call	I_PlayCommand		;
	jmp	I_Play_Loop		;Loop
I_Loop_Step2:				;
	call	I_PlayKey		;
	jmp	I_Play_Loop		;Loop
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				KeyOn,KeyOff		*
;*								*
;****************************************************************
;*	WX^gp						*
;*		ax	ėp(ɌvZ)				*
;*		ds:bx	L\̃AhX			*
;*		cx	ėp(ɃJE^)			*
;*		dx	ėp(ɌvZ)				*
;*		ds:di	ʍ\				*
;*		ds:bp	[Nx[XAhX			*
;*		es:si	tAhX				*
;****************************************************************
;===============================================================|
;			KeyOn (Hardware,Software)		|
;===============================================================|
	even				;AhXzu
I_Play_KeyOn:				;
	cmp	ds:[di].WTD_Key,0ffh	;xH
	jnz	I_Play_KeyOn_Start	;
	jmp	I_Play_KeyOn_End	;

	even				;AhXzu
I_Play_KeyOn_Start:			;
	pusha				;WX^ۑ

;Ỏ́A^CH
	test	ds:[di].WTD_FlagTai,02h	;O^CH
	jnz	I_Play_KeyOn_StepEnd	;

;F
	mov	al,ds:[di].WTD_Program2nd	;'@'R}h
	and	al,ds:[di].WTD_Program3rd	;Kv̊mF
	and	al,080h				;2,3p[^̎w肪
	jnz	I_Play_KeyOn_Step8		;A͖B
	mov	al,ds:[di].WTD_Program1st	;
	and	al,07fh				;bit̃}XN
	mov	dx,offset CGROUP:I_Table_Voice	;
	call	I_Table_Jump			;
I_Play_KeyOn_Step8:				;

;Emb͏KvB
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_ExprEmb
	jz	I_Play_KeyOn_Step4		;
	mov	cx,WTD_Ctrl_EmbVol		;
	mov	dx,WTD_ExprEmb			;
	call	I_Play_KeyOn_Emb		;
	jmp	I_Play_KeyOn_Step4End		;
I_Play_KeyOn_Step4:				;
	mov	ds:[di].WTD_ExprEmbLevelSet,0ffh
I_Play_KeyOn_Step4End:				;

	test	ds:[di].WTD_FlagControl,0037h	;Emb͏KvB
	jz	I_Play_KeyOn_Step7	;\tgEFAȂ΂B

;LFO
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_BendLfo
	jz	I_Play_KeyOn_Step1		;
	mov	dx,WTD_BendLFO			;
	call	I_Play_KeyOn_LFO		;
I_Play_KeyOn_Step1:				;

;Emb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_BendEmb
	jz	I_Play_KeyOn_Step2		;
	mov	cx,WTD_Ctrl_EmbFreq		;
	mov	dx,WTD_BendEmb			;
	call	I_Play_KeyOn_Emb		;
I_Play_KeyOn_Step2:				;

;LFO
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_ExprLFO
	jz	I_Play_KeyOn_Step3		;
	mov	dx,WTD_ExprLFO			;
	call	I_Play_KeyOn_LFO		;
I_Play_KeyOn_Step3:				;

;pLFO
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PanLFO
	jz	I_Play_KeyOn_Step5		;
	mov	dx,WTD_PanLFO			;
	call	I_Play_KeyOn_LFO		;
I_Play_KeyOn_Step5:				;

;pEmb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PanEmb
	jz	I_Play_KeyOn_Step6		;
	mov	cx,WTD_Ctrl_EmbPan		;
	mov	dx,WTD_PanEmb			;
	call	I_Play_KeyOn_Emb		;
I_Play_KeyOn_Step6:				;

;W[V
I_Play_KeyOn_Step7:
ifndef	hyoka	;--------------------------------ł͖
	xor	ax,ax				;
	cmp	ds:[di].WTD_ModLevelSet,al	;
	jz	I_Play_KeyOn_StepEnd		;OƂȂH
	mov	ds:[di].WTD_ModLevelSet,al	;
	mov	cl,MIDI_Ctrl_Mod		;
	mov	dx,offset CGROUP:I_Table_CtrlChgB
	call	I_Table_Jump			;W[VOɂB
endif	;----------------------------------------

I_Play_KeyOn_StepEnd:			;
	popa				;WX^A

I_Play_KeyOn_End:			;
	ret				;
;===============================================================|
;			KeyOff (Hardware,Software)		|
;===============================================================|
	even				;AhXzu
I_Play_KeyOff:
	test	ds:[di].WTD_FlagTai,01h	;^CH
	jnz	I_Play_KeyOff_End	;

I_Play_KeyOff_Start:			;
	pusha				;WX^ۑ

;n[hEFAKeyOff
	mov	dx,offset CGROUP:I_Table_KeyOff	;
	call	I_Table_Jump			;KeyOff

;F
	test	ds:[di].WTD_Program3rd,80h	;'@'R}h
	jnz	I_Play_KeyOff_Step5		;Kv̊mF
	mov	al,ds:[di].WTD_Program3rd	;
	and	al,07fh				;bit̃}XN
	mov	dx,offset CGROUP:I_Table_Voice	;
	call	I_Table_Jump			;
I_Play_KeyOff_Step5:				;

;Emb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_BendEmb
	jz	I_Play_KeyOff_Step1		;
	mov	cx,WTD_Ctrl_EmbFreq		;
	mov	dx,WTD_BendEmb			;
	call	I_Play_KeyOff_Emb		;
I_Play_KeyOff_Step1:				;

;Emb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_ExprEmb
	jz	I_Play_KeyOff_Step2		;
	mov	cx,WTD_Ctrl_EmbVol		;
	mov	dx,WTD_ExprEmb			;
	call	I_Play_KeyOff_Emb		;
	jmp	I_Play_KeyOff_StepEnd		;
I_Play_KeyOff_Step2:				;
	test	ds:[di].WTD_Channel,80h		;MIDIp[g̏ꍇ͑삵ȂB
	jz	I_Play_KeyOff_Step3		;
	mov	ds:[di].WTD_ExprEmbLevelSet,000h
I_Play_KeyOff_Step3:				;

;pEmb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PanEmb
	jz	I_Play_KeyOff_Step4		;
	mov	cx,WTD_Ctrl_EmbPan		;
	mov	dx,WTD_PanEmb			;
	call	I_Play_KeyOff_Emb		;
I_Play_KeyOff_Step4:				;

I_Play_KeyOff_StepEnd:				;
	popa					;WX^A

I_Play_KeyOff_End:			;
	ret				;
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				Eʐ			*
;****************************************************************
;*	WX^gp						*
;*		ax	ėp(ɌvZ)				*
;*		ds:bx	L\̃AhX			*
;*		cx	ėp					*
;*		dx	[NAhX擪(ʍ\)		*
;*		ds:di	ʍ\				*
;*		ds:bp	[Nx[XAhX			*
;*		es:si	tAhX				*
;****************************************************************
;===============================================================|
;			 (Detune,LFO,Emb)		|
;===============================================================|
	even				;AhXzu
I_Play_Frection:			;
	pusha				;

;W[V(MIDI)
ifndef	hyoka	;--------------------------------ł͖
	mov	ax,ds:[di].WTD_Leng		;W[V
	sub	ax,ds:[di].WTD_LengCounter	;
	cmp	ax,ds:[di].WTD_ModDecay		;
	jnz	I_Play_Frection_Step4		;
	mov	al,ds:[di].WTD_ModLevel		;
;	cmp	ds:[di].WTD_ModLevelSet,al	;
;	jz	I_Play_Frection_Step4		;ł͂Ȃł傤B
	mov	ds:[di].WTD_ModLevelSet,al	;
	mov	cl,MIDI_Ctrl_Mod		;
	mov	dx,offset CGROUP:I_Table_CtrlChgB
	call	I_Table_Jump			;W[VB
endif	;----------------------------------------
I_Play_Frection_Step4:				;


;ǂݍ
	mov	ax,ds:[di].WTD_Bend	;

;fB`[̉Z
	add	ax,ds:[di].WTD_BendDetune

;LFO
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_BendLFO
	jz	I_Play_Frection_Step1	;
	mov	dx,WTD_BendLFO		;
	call	I_Play_LFO		;
	add	ax,dx			;
I_Play_Frection_Step1:			;

;Emb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_BendEmb
	jz	I_Play_Frection_Step2	;
	mov	cx,WTD_Ctrl_EmbFreq	;
	mov	dx,WTD_BendEmb		;
	call	I_Play_Emb		;
	sub	dl,80h			
	jnc	I_Play_Frection_Step3	;
	mov	dh,0ffh			;dxdl(t)
I_Play_Frection_Step3:			;
	shl	dx,6			;~2^6
	add	ax,dx			;Z
I_Play_Frection_Step2:			;

;̏o
	mov	dx,offset CGROUP:I_Table_Frection
	call	I_Table_Jump		;Zbg

	popa				;
	ret				;
;===============================================================|
;			ʐ (Detune,LFO,Emb)		|
;===============================================================|
	even				;AhXzu
I_Play_Volume:				;
	pusha				;

;ʓǂݍ݁14bitɕϊ
	xor	ax,ax			;
	mov	al,ds:[di].WTD_Expr	;
	inc	ax			;
	shl	ax,7			;128{ɂB
	dec	ax			;iRange:0`16383j

;fB`[̉Z
	add	ax,ds:[di].WTD_ExprDetune

;LFO
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_ExprLFO
	jz	I_Play_Volume_Step1	;
	mov	dx,WTD_ExprLFO		;
	call	I_Play_LFO		;
	add	ax,dx			;
I_Play_Volume_Step1:			;

;Emb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_ExprEmb
	jz	I_Play_Volume_Step2	;
	mov	cx,WTD_Ctrl_EmbVol	;
	mov	dx,WTD_ExprEmb		;
	call	I_Play_Emb		;
;	mov	ds:[di].WTD_ExprEmbLevelSet,dl	;Gx[vl
I_Play_Volume_Step2:			;

;ʂA7bitɕ␳
	inc	ax			;
	shr	ax,7			;ax{(ax+1)128}-1
	dec	ax			;iRange:0`127j
	test	ah,ah			;
	jnz	I_Play_Volume_Step4	;
	test	al,080h			;
	jz	I_Play_Volume_Step5	;
I_Play_Volume_Step3:			;if (128=>ax>255){
	mov	al,07fh			;	al = 0x7F;
	jmp	I_Play_Volume_Step5	;}
I_Play_Volume_Step4:			;if (ax>255){
	mov	al,000h			;	al = 0x00;
I_Play_Volume_Step5:			;}

;Gx[vʂ̍
	xor	cx,cx			;
	mov	cl,al			;
	inc	cx				;cx+1
	xor	ax,ax				;ax0
	mov	al,ds:[di].WTD_ExprEmbLevelSet	;ax
	inc	ax				;ax\tg+1
	mul	cx			;
	dec	ax			;
	shl	ax,1			;al((Vol.+1)~(SoftVol.+1)-1)^128
	mov	al,ah			;(Range:0`255)

;\tgEFAʂ̍
	xor	cx,cx			;
	mov	cl,al			;
	inc	cx			;cx+1
	xor	ax,ax			;ax0
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_Effect
	jnz	I_Volume_SoftEffect		;ʉH
	mov	al,ds:[bx].WTD_Sys_VolumeMusic	;axy
	jmp	I_Volume_SoftEnd		;
I_Volume_SoftEffect:				;
	mov	al,ds:[bx].WTD_Sys_VolumeEffect	;axʉ
I_Volume_SoftEnd:				;
	mov	bx,offset CGROUP:I_Volume_Table	;logZ
	mov	si,ax			;
	and	si,00ffh		;
	mov	al,cs:[bx + si]		;
	inc	ax			;ax\tg+1
	mul	cx			;
	dec	ax			;al((2*Vol.+1)~(SoftVol.+1)^256)-1
	mov	al,ah			;(Range:0`255)
	shr	al,1			;al2 (Range:0`127)

;ʂ̏o
	mov	dx,offset CGROUP:I_Table_Volume
	call	I_Table_Jump		;ʃZbg

	popa				;
	ret				;
;===============================================================|
;			p|bg (LFO,Emb)		|
;===============================================================|
	even				;AhXzu
I_Play_Pan:				;
	pusha				;

;p|bgǂݍ
	mov	al,ds:[di].WTD_Pan	;
	and	ax,0007fh		;

	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PanLFO + WTD_Ctrl_PanEmb
	jz	I_Play_Pan_Output	;\tgEFAȂ΂B

;128{ɂB
	inc	ax			;
	shl	ax,7			;
	dec	ax			;iRange:0`16383j

;p|bgLFO
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PanLFO
	jz	I_Play_Pan_Step1	;
	mov	dx,WTD_PanLFO		;
	call	I_Play_LFO		;
	add	ax,dx			;
I_Play_Pan_Step1:			;

;p|bgEmb
	test	ds:[di].WTD_FlagControl,WTD_Ctrl_PanEmb
	jz	I_Play_Pan_Step2	;
	mov	cx,WTD_Ctrl_EmbPan	;
	mov	dx,WTD_PanEmb		;
	call	I_Play_Emb		;
	sub	dl,80h			;
	jnc	I_Play_Pan_Step3	;
	mov	dh,0ffh			;dxdl(t)
I_Play_Pan_Step3:			;
	shl	dx,6			;~2^6
	add	ax,dx			;Z
I_Play_Pan_Step2:			;

;p|bgA7bitɕ␳
	inc	ax			;
	shr	ax,7			;ax{(ax+1)128}-1
	dec	ax			;iRange:0`127j
	test	ah,ah			;
	jnz	I_Play_Pan_Step5	;
	test	al,080h			;
	jz	I_Play_Pan_Step6	;
I_Play_Pan_Step4:			;if (128=>ax>255){
	mov	al,07fh			;	al = 0x7F;
	jmp	I_Play_Pan_Step6	;}
I_Play_Pan_Step5:			;if (ax>255){
	mov	al,000h			;	al = 0x00;
I_Play_Pan_Step6:			;}

;p|bg̏o
I_Play_Pan_Output:
	cmp	ds:[di].WTD_PanSet,al	;Ȃ΁AvȂB
	jz	I_Play_Pan_End		;
	mov	ds:[di].WTD_PanSet,al	;
ifndef	hyoka	;------------------------ł͖
	mov	cl,MIDI_Ctrl_Pan	;
	mov	dx,offset CGROUP:I_Table_CtrlChgB
	call	I_Table_Jump		;p|bgZbg
endif	;--------------------------------

I_Play_Pan_End:
	popa				;
	ret				;
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				ELFO,Emb		*
;*				Aʂœ̃[`	*
;*								*
;****************************************************************
;*	WX^gp						*
;*		ax	ėp(ɌvZ)				*
;*		ds:bx	L\̃AhX			*
;*		cx	ėp(ɃJE^)			*
;*		dx	[NAhX擪(ʍ\)		*
;*		ds:di	ʍ\				*
;*		ds:bp	[Nx[XAhX			*
;*		es:si	tAhX				*
;*	Ԃl						*
;*		dx	ψ(x)				*
;****************************************************************
;===============================================================|
;			LFO	KeyOn				|
;===============================================================|
	even				;AhXzu
I_Play_KeyOn_LFO:				;
	push	ax				;
	push	bp				;WX^ۑ

	mov	bp,dx					;

;JE^[(Rate)̏
	mov	ah,ds:[di + bp].WTD_ChLfo_DecayRate	;DR
	add	ah,ds:[di + bp].WTD_ChLfo_SpeedRate	;SR
	mov	ds:[di + bp].WTD_ChLfo_RateCounter,ah	;

;JE^[(Count)̏
	mov	ah,ds:[di + bp].WTD_ChLfo_Count		;
	shr	ah,1					;ah = ah / 2
	mov	ds:[di + bp].WTD_ChLfo_CountCounter,ah	;

;x̏
	xor	ax,ax					;
	mov	ds:[di + bp].WTD_ChLfo_LevelSet,ax	;

	pop	bp					;WX^A
	pop	ax					;
	ret						;
;===============================================================|
;			Emb	KeyOn				|
;===============================================================|
	even				;AhXzu
I_Play_KeyOn_Emb:				;
	pusha					;

	xchg	bp,dx				;

	mov	al,ds:[di + bp].WTD_ChEmb_Address	;
	and	al,0f0h					;
	mov	ds:[di + bp].WTD_ChEmb_Address,al	;ʒu

	mov	ah,00h				;ʃAhX̐ݒ
	test	ds:[di].WTD_FlagControl,cx	;
	jz	I_Play_KeyOn_Emb_Step1		;
	mov	ah,01h				;
I_Play_KeyOn_Emb_Step1:				;

	mov	bx,dx				;bxx[XAhX
	add	bx,WTD_WorkAdd_Emb		;Gx[vAhX
	add	bx,ax				;f[^AhX
	mov	ax,ds:[bx]			;ǂݍ݁B
	add	bx,2				;
	mov	dx,ds:[bx]			;

	mov	ds:[di + bp].WTD_ChEmb_Rate,al		;
	cmp	ah,80h					;ah́AΒlƂB
	jc	I_Play_KeyOn_Emb_Step9			;
	neg	ah					;
I_Play_KeyOn_Emb_Step9:					;
	mov	ds:[di + bp].WTD_ChEmb_Counter,ah	;
	mov	ds:[di + bp].WTD_ChEmb_MaxMin,dl	;
	mov	ds:[di + bp].WTD_ChEmb_LevelSet,dh	;

	popa					;
	ret					;
;===============================================================|
;			Emb	KeyOff				|
;===============================================================|
	even				;AhXzu
I_Play_KeyOff_Emb:				;
	pusha					;

	xchg	bp,dx				;

	mov	al,ds:[di + bp].WTD_ChEmb_Address	;
	and	al,0f0h					;
	or	al,00cH					;
	mov	ds:[di + bp].WTD_ChEmb_Address,al	;ʒu

I_Play_KeyOnOff_Emb:					;

	mov	ah,00h				;ʃAhX̐ݒ
	test	ds:[di].WTD_FlagControl,cx	;
	jz	I_Play_KeyOff_Emb_Step1		;
	mov	ah,01h				;
I_Play_KeyOff_Emb_Step1:			;

	mov	bx,dx				;bxx[XAhX
	add	bx,WTD_WorkAdd_Emb		;Gx[vAhX
	add	bx,ax				;f[^AhX
	mov	ax,ds:[bx]			;ǂݍ݁B
	add	bx,2				;
	mov	dx,ds:[bx]			;

	mov	ds:[di + bp].WTD_ChEmb_Rate,al		;
	cmp	ah,80h					;ah́AΒlƂB
	jc	I_Play_KeyOff_Emb_Step9			;
	neg	ah					;
I_Play_KeyOff_Emb_Step9:				;
	mov	ds:[di + bp].WTD_ChEmb_Counter,ah	;
	mov	ds:[di + bp].WTD_ChEmb_MaxMin,dl	;

	popa					;
	ret					;
;===============================================================|
;			Emb	C				|
;===============================================================|
	even				;AhXzu
I_Play_Emb:					;
	push	bp				;
	push	bx				;WX^ۑ
	push	ax				;

	xchg	bp,dx				;

;Speed
	sub	ds:[di + bp].WTD_ChEmb_Counter,1
	jz	I_Play_Emb_Step1		;
	jmp	I_Play_Emb_End			;
I_Play_Emb_Step1:				;

;AhX̐ݒ
	mov	ah,00h				;ʃAhX̐ݒ
	test	ds:[di].WTD_FlagControl,cx	;
	jz	I_Play_Emb_Step2		;
	mov	ah,01h				;
I_Play_Emb_Step2:				;axAddress
	mov	al,ds:[di + bp].WTD_ChEmb_Address
	mov	bx,dx				;bxx[XAhX
	add	bx,WTD_WorkAdd_Emb		;Gx[vAhX
	add	bx,ax				;bxf[^AhX

;CountĐݒ
	mov	ah,ds:[bx].WTD_Emb_AS		;
	cmp	ah,80h				;ah́AΒlƂB
	jc	I_Play_Emb_Step5		;
	neg	ah				;
I_Play_Emb_Step5:				;
	mov	ds:[di + bp].WTD_ChEmb_Counter,ah

;Rate
	mov	al,ds:[di + bp].WTD_ChEmb_LevelSet
	cmp	ds:[bx].WTD_Emb_AS,80h		;r( or )
	jc	I_Play_Emb_Step7		;
	sub	al,ds:[bx].WTD_Emb_AR		;
	jmp	I_Play_Emb_Step8		;
I_Play_Emb_Step7:				;
	add	al,ds:[bx].WTD_Emb_AR		;
I_Play_Emb_Step8:				;
	jc	I_Play_Emb_Step3		;

;Level
	cmp	ds:[bx].WTD_Emb_AS,80h		;r( or )
	jc	I_Play_Emb_Step4		;
	cmp	al,ds:[bx].WTD_Emb_AL		; ŏl`FbN
	jc	I_Play_Emb_Step3		;
	jmp	I_Play_Emb_StepEnd		;
I_Play_Emb_Step4:				; ől`FbN
	cmp	al,ds:[bx].WTD_Emb_AL		;
	jnc	I_Play_Emb_Step3		;
	jmp	I_Play_Emb_StepEnd		;

;ől𒴂ꍇ
I_Play_Emb_Step3:					;
	mov	al,ds:[bx].WTD_Emb_AL			;
	mov	ah,ds:[di + bp].WTD_ChEmb_Address	;
	and	ah,0fh					;
	cmp	ah,08h					;
	jnc	I_Play_Emb_StepEnd			;

	push	ax					;
	add	ds:[di + bp].WTD_ChEmb_Address,04h	;
	add	bx,4					;AhX̐ݒ
	mov	ax,ds:[bx]				;ǂݍ݁B
	add	bx,2					;
	mov	dx,ds:[bx]				;
	mov	ds:[di + bp].WTD_ChEmb_Rate,al		;
	cmp	ah,80h					;ah́AΒlƂB
	jc	I_Play_Emb_Step6			;
	neg	ah					;
I_Play_Emb_Step6:					;
	mov	ds:[di + bp].WTD_ChEmb_Counter,ah	;
	mov	ds:[di + bp].WTD_ChEmb_MaxMin,dl	;
	pop	ax					;

I_Play_Emb_StepEnd:				;
	mov	ds:[di + bp].WTD_ChEmb_LevelSet,al

I_Play_Emb_End:					;
	xor	dx,dx				;
	mov	dl,ds:[di + bp].WTD_ChEmb_LevelSet

	pop	ax				;
	pop	bx				;
	pop	bp				;
	ret					;
;===============================================================|
;			LFO	C				|
;===============================================================|
	even				;AhXzu
I_Play_LFO:					;
	push	ax				;
	push	bp				;WX^ۑ

	mov	bp,dx				;

;Rate
	sub	ds:[di + bp].WTD_ChLfo_RateCounter,1	;
	jnz	I_Play_LFO_End				;
	mov	al,ds:[di + bp].WTD_ChLfo_SpeedRate	;
	mov	ds:[di + bp].WTD_ChLfo_RateCounter,al	;

;Level(dxLevel)
	mov	dx,ds:[di + bp].WTD_ChLfo_LevelSet	;dxLevel
	mov	al,ds:[di + bp].WTD_ChLfo_CountCounter	;
	mov	ah,ds:[di + bp].WTD_ChLfo_Count		;Z̕
	cmp	al,ah					;
	jz	I_Play_LFO_Add				;
	jc	I_Play_LFO_Add				;
I_Play_LFO_Sub:						;
	sub	dx,ds:[di + bp].WTD_ChLfo_Level		;Z
	jmp	I_Play_LFO_Step				;
I_Play_LFO_Add:						;
	add	dx,ds:[di + bp].WTD_ChLfo_Level		;Z
I_Play_LFO_Step:					;
	mov	ds:[di + bp].WTD_ChLfo_LevelSet,dx	;ۑ

;Count
	sub	ds:[di + bp].WTD_ChLfo_CountCounter,1	;
	jnz	I_Play_LFO_End				;
	mov	al,ds:[di + bp].WTD_ChLfo_Count		;JE^[
	shl	al,1					;al = al ~ 2
	mov	ds:[di + bp].WTD_ChLfo_CountCounter,al	;

I_Play_LFO_End:
	mov	dx,DS:[di + bp].WTD_ChLfo_LevelSet	;dxLFÕx

	pop	bp				;WX^A
	pop	ax				;
	ret					;
;****************************************************************
;*								*
;*			ʉI̐ݒ蕜A			*
;*								*
;****************************************************************
;*								*
;*		ch	`l				*
;*		ds:bx	System Sturuc				*
;*		ds:di	Part Sturuc				*
;****************************************************************
	even				;AhXzu
I_Effect_Return:				;
	pusha					;WX^ۑ
;---------------------------------------------------------------
;tÕZbg
	mov	cl,ch				;
	and	cl,07h				;
	inc	cl				;
	mov	ax,0f7ffh			;
	rol	ax,cl				;
	and	ds:[bx].WTD_Sys_Flag,ax		;
;---------------------------------------------------------------
;Channel Mode̕A
	mov	ax,ds:[bx].WTD_Sys_Flag		;ahChannel Mode Flag
	and	ah,0fh				;ah̑FlagMask
	shl	ah,4				;
	xchg	ah,al				;
	mov	ah,08h				;ah08h
	mov	cl,ch				;
	and	cl,07h				;5bit}XN
	inc	cl				;
	shl	ah,cl				;ah = ah*2^cl (SetBit)
	call	SP_Set_Channel			;

;---------------------------------------------------------------
;p[g

;p[g
	mov	cl,20				;20񃋁[v
	mov	di,bp				;
	add	di,WTD_WorkAdd_Ch0		;di\̃AhX
I_Effect_Return_Loop0:				;
	cmp	byte ptr ds:[di].WTD_Channel,ch	;
	jz	I_Effect_Return_Step0		;
	add	di,WTD_WorkChSize		;\̂̃TCY80h(0x80)
	dec	cl				;
	jnz	I_Effect_Return_Loop0		;
	jmp	I_Effect_Return_End		;͎gĂȂB
I_Effect_Return_Step0:

;A
	and	ch,03h				;`l񂾂ɂB
;g
	mov	ax,ds:[di].WTD_FrectionSet	;g̕A
	call	SP_Set_Frection			;
;
	mov	al,ds:[di].WTD_ExprPanSet	;ʂ̕A
	call	SP_Set_Volume			;
;F
	push	si				;F̕A
	mov	si,bp				;
	add	si,WTD_WorkAdd_Wave		;
	xor	ax,ax				;
	mov	al,ds:[di].WTD_Voice		;
	shl	ax,4				;
	add	si,ax				;ds:siF̂AhX
	call	SP_Set_Voice			;
	pop	si				;
;XEB[vl(ch=02h)
	cmp	ch,2				;XEB[vl̕A
	jnz	I_Effect_Return_Step2		;
	mov	al,ds:[di].WTD_SweepLevel	;
	mov	ah,ds:[di].WTD_SweepTime	;
	call	SP_Set_Sweep			;
I_Effect_Return_Step2:				;
;mCY[h(ch=03h)
	cmp	ch,3				;mCY[h̕A
	jnz	I_Effect_Return_Step3		;
	mov	ah,01fh				;
	mov	al,ds:[di].WTD_NoiseMode	;
	or	al,018h				;
	and	al,ah				;
	call	SP_Set_Noise			;
I_Effect_Return_Step3:				;

;---------------------------------------------------------------
I_Effect_Return_End:
	popa					;WX^A
	ret					;
