;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Un MML Compiler Program			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|

assume	cs:code,ds:code,es:code,ss:code

code	segment

.186

	org	0100h

Dat2Asm_End_:
;=======================================================================|
;				Start Up				|
;=======================================================================|
	jmp	_main			;C[`
;=======================================================================|
;				define					|
;=======================================================================|
WtdIL_Name		equ	'WTD',0
MusicMaxPart		equ	20	;ił20p[g
EffectMaxPart		equ	3	;ʉ3 p[g
;
;		RpC
;
D_ZEN	DB	128		;P	l
;=======================================================================|
;				Start					|
;=======================================================================|
include	wtd_ver.inc	;WTD Version infomation
include	wtd_def.inc	;WTD Define infomation
include	WSMAKE.INC	;
include	D2A_SUB.ASM	;sub routine
include	D2A_CNV.ASM	;convert routine
;****************************************************************
;*		IvV					*
;****************************************************************
OP_FLAG_LEN	DB	4			;IvVtO|w
OP_FLAG_HELP	DB	0			;IvVtO|wv\
OP_FLAG_FILE	DB	081H	DUP(00H)	;t@CiPQWj
OP_HELP	DB	0DH,0AH
	DB	"	Converter from a binary to a DB command",0DH,0AH
	DB	"			Programmed by  A.Watanabe",0DH,0AH
	DB	0DH,0AH
	DB	"	 [32;4m Filename[32;0m [m"
	DB	"t@C̓ǂݍ",0DH,0AH
	DB	"	>[32;4m Filename[32;0m [m"
	DB	"t@C֏",0DH,0AH
	DB	"	/B : DBߏóiBytej",0DH,0AH
	DB	"	/W : DWߏóiWordj",0DH,0AH
	DB	"	/D : DDߏóiDouble Wordj",0DH,0AH
	DB	"	/? :wv̕\",0DH,0AH
	DB	024H
;****************************************************************
;*		IvVtO				*
;****************************************************************
;	gpWX^						*
;	BX	IvVAhX			*
;	CX	IvVŏIAhX{P		*
;****************************************************************
OPTION_FLAG:				;
	MOV	AX,CS			;
	MOV	DS,AX			;DSCS

	MOV	AX,0000H		;
	MOV	BX,0080H		;BXIvV擪AhX|P
	MOV	AL,CS:[BX]		;ALIvV
	ADD	AX,BX			;
	MOV	CX,AX			;CXI[vVŏIԒn
OP_LOOP:
	INC	BX			;
	CMP	CX,BX			;IvVI
	JNC	OP_LP0			;tOďI
	RET				;
OP_LP0:
	MOV	AL,CS:[BX]		;ǂݍ
	CMP	AL,21H			;
	JC	OP_LOOP			;
	CMP	AL,"/"			;'/'or'-'łAIvV
	JZ	OP_SW			;
	CMP	AL,"-"			;
	JZ	OP_SW			;
	JMP	OP_FILE_SET		;ȊO̓t@Cw
OP_SW:
	INC	BX			;AhXCNg
	CMP	CX,BX			;IvVIH
	JNC	OP_S00			;
	JMP	OPTION_ERROR		;G[
OP_S00:	
	MOV	AH,0FFH			;tOėpB
	MOV	DX,OFFSET OP_FLAG_HELP	;tOAhX
	MOV	AL,CS:[BX]		;
	CMP	AL,"?"			;Help\
	JNZ	OP_S01			;
	JMP	OP_FLAG_SET		;
OP_S01:	CMP	AL,"h"			;
	JNZ	OP_S02			;
	JMP	OP_FLAG_SET		;
OP_S02:	CMP	AL,"H"			;
	JNZ	OP_S03			;
	JMP	OP_FLAG_SET		;
OP_S03:	

	MOV	DX,OFFSET OP_FLAG_LEN	;DBߎw
	mov	ah,1			;
	CMP	AL,"b"			;
	JNZ	OP_S04			;
	JMP	OP_FLAG_SET		;
OP_S04:	CMP	AL,"B"			;
	JNZ	OP_S05			;
	JMP	OP_FLAG_SET		;
OP_S05:	

	mov	ah,2			;DWߎw
	CMP	AL,"w"			;
	JNZ	OP_S06			;
	JMP	OP_FLAG_SET		;
OP_S06:	CMP	AL,"W"			;
	JNZ	OP_S07			;
	JMP	OP_FLAG_SET		;
OP_S07:	

	mov	ah,4			;DDߎw
	CMP	AL,"d"			;
	JNZ	OP_S08			;
	JMP	OP_FLAG_SET		;
OP_S08:	CMP	AL,"D"			;
	JNZ	OP_S09			;
	JMP	OP_FLAG_SET		;
OP_S09:	

OP_SEE:	JMP	OPTION_ERROR		;G[
;****************************************************************
OP_FLAG_SET:
	XCHG	BX,DX			;
	MOV	CS:[BX],AH		;tOZbg
	XCHG	BX,DX			;
	JMP	OP_LOOP			;[vɖ߂
;****************************************************************
OP_FILE_SET:
	MOV	DX,OFFSET OP_FLAG_FILE	;t@CׁB
	XCHG	BX,DX			;
	MOV	AH,CS:[BX]		;
	XCHG	BX,DX			;
	CMP	AH,0			;tOOȊOH
	JZ	OP_FILE_SET_1		;
	JMP	OPTION_ERROR		;t@CQĂ悧`
OP_FILE_SET_1:
	DEC	BX			;IvV|C^߂
	PUSH	CX			;WX^ۑ
	MOV	CX,080H			;t@Cigq܁jőTCY
OP_FILE_SET_2:
	INC	BX			;
	MOV	AL,CS:[BX]		;ALǂݍ
	CMP	AL,21H			;ŌH
	JC	OP_FILE_SET_3		;
	XCHG	BX,DX			;
	MOV	CS:[BX],AL		;Zbg
	XCHG	BX,DX			;
	INC	DX			;CNg
	DEC	CX			;PQWH
	JNZ	OP_FILE_SET_2		;
OP_FILE_SET_3:
	MOV	AL,0			;
	XCHG	BX,DX			;
	MOV	CS:[BX],AL		;'0' Zbg
	XCHG	BX,DX			;
	POP	CX			;WX^A
	JMP	OP_LOOP			;[vɖ߂
;=======================================================================|
;		^ݒ							|
;=======================================================================|
OPTION_LEN:				;
;	PUSH	AX			;
;	MOV	AL,CS:[OP_FLAG_LEN]	;
;	MOV	CS:[D_ZEN],AL		;ݒ
;	POP	AX			;
	RET				;RETURN
;=======================================================================|
;		wv							|
;=======================================================================|
OPTION_HELP:				;
	MOV	DX,OFFSET OP_HELP	;\
	MOV	AH,09H			;
	INT	21H			;
	JMP	COMEND			;vOI
;=======================================================================|
;		t@Cݒ						|
;=======================================================================|
OPTION_FILE:				;
	pusha				;

	;hWtd_File = file_open(0,OP_FLAG_FILE);
	push	cs			;
	pop	ds			;
	mov	dx,offset OP_FLAG_FILE	;DS:DXt@CAhX
	mov	ax,0			;AXRead
	call	File_Open		;
	mov	word ptr cs:[hWtd_File],ax

;t@C̃[h
	;szWtd_File = file_close(hWtd_File,segWtd_File);
	push	ds			;
	mov	ax,word ptr cs:[segWtd_File]
	mov	ds,ax			;
	mov	dx,0			;ds:dxobt@
	mov	ax,word ptr cs:[hWtd_File]
	call	File_Load		;
	mov	word ptr cs:[szWtd_File],ax
	pop	ds			;

;t@C̃N[Y
	;file_close(hWtd_File);
	mov	ax,word ptr cs:[hWtd_File]
	call	File_Close		;

	popa				;
	RET				;RETURN
;=======================================================================|
;		IvV						|
;=======================================================================|
operr_msg	db	'IvVsłB',0ah,0dh,24h
OPTION_ERROR:
	push	cs			;G[
	pop	ds			;
	mov	dx,offset operr_msg	;
	mov	ah,09h			;
	int	21h			;
	jmp	COMEND			;
;=======================================================================|
;		IvV						|
;=======================================================================|
Op_:
	CALL	OPTION_FLAG		;tO
	MOV	AL,0			;`FbNp
OP_L00:	CMP	CS:[OP_FLAG_LEN],AL	;o͏
	JZ	OP_L01			;
	CALL	OPTION_LEN		;
OP_L01:	CMP	CS:[OP_FLAG_HELP],AL	;wv\
	JZ	OP_L02			;
	CALL	OPTION_HELP		;
OP_L02:	CMP	CS:[OP_FLAG_FILE],AL	;t@Cǂݍ
	JZ	OP_L03			;
	CALL	OPTION_FILE		;
	jmp	OP_LEE			;
OP_L03:	jmp	COMEND			;t@C̎w肪΁A
OP_LEE:	RET				;RETURN
;=======================================================================|
;				main					|
;=======================================================================|
_main:
	MOV	AX,OFFSET Dat2Asm_End + BSTACK	;
	MOV	SP,AX			;

	MOV	AX,CS			;
	MOV	DS,AX			;
	MOV	ES,AX			;ZOgււցB
	MOV	SS,AX			;

	call	ComSmole		;̍ŏ

	mov	ax,01000h		;
	call	Memory_Open		;
	mov	word ptr cs:[segWtd_File],ax

	call	Op_			;IvV

	call	convert			;tllkRpC

	mov	ax,word ptr cs:[segWtd_File]
	call	Memory_Close		;̉

_main_End:
COMEND:
	STI				;荞݋
	MOV	AX,04C00H		;
	INT	21H			;MS-DOS RET
;=======================================================================|
;				End					|
;=======================================================================|
Dat2Asm_End:
CODE	ENDS
	END	Dat2Asm_End_
